//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2000 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

// MACROS ------------------------------------------------------------------

// CONSTANTS ---------------------------------------------------------------

// TYPES -------------------------------------------------------------------

// FUNCTION PROTOTYPES -----------------------------------------------------

// DATA DECLARATIONS -------------------------------------------------------

// CODE --------------------------------------------------------------------

//==========================================================================
//
//	A_Hoof
//
//	Cyberdemon move with hoof sound.
//
//==========================================================================

void A_Hoof(mobj_t *mo)
{
    StartSoundName(mo, "CyberWalk1");
    A_Chase(mo);
}

//==========================================================================
//
//	A_Metal
//
//	Cyberdemon move with metal sound.
//
//==========================================================================

void A_Metal(mobj_t *mo)
{
    StartSoundName(mo, "CyberWalk2");
    A_Chase(mo);
}

//==========================================================================
//
//	A_CyberAttack
//
//	Cyberdemon attack.
//
//==========================================================================

void A_CyberAttack(mobj_t *actor)
{	
    if (!actor->target)
		return;
		
    A_FaceTarget(actor);
    SpawnMissile(actor, actor->target, MT_ROCKET);
}

