//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2000 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

// MACROS ------------------------------------------------------------------

// CONSTANTS ---------------------------------------------------------------

// TYPES -------------------------------------------------------------------

// FUNCTION PROTOTYPES -----------------------------------------------------

// DATA DECLARATIONS -------------------------------------------------------

// CODE --------------------------------------------------------------------

//==========================================================================
//
//	A_SPosAttack
//
//  Shotgun guy, Spider mastermind attack.
//
//==========================================================================

void A_SPosAttack(mobj_t *actor)
{
    int			i;
    int			damage;
	TAVec		bangles;
	TAVec		angles;
	TVec		vforward;

    if (!actor->target)
		return;

    StartSoundName(actor, "ShotgunFire");
    A_FaceTarget(actor);
	avcpy(actor->angles, bangles);
    AimLineAttack(actor, &bangles, MISSILERANGE);
    for (i = 0; i < 3; i++)
    {
		avcpy(bangles, angles);
 		angles.yaw += (P_Random() - P_Random()) << 20;
		AngleVector(&angles, &vforward);
		damage = ((P_Random() % 5) + 1) * 3;
		LineAttack(actor, &vforward, MISSILERANGE, damage);
    }

	actor->effects |= EF_DL_MUZZLEFLASH;
}

