//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2000 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

// MACROS ------------------------------------------------------------------

// CONSTANTS ---------------------------------------------------------------

// TYPES -------------------------------------------------------------------

// FUNCTION PROTOTYPES -----------------------------------------------------

// DATA DECLARATIONS -------------------------------------------------------

// CODE --------------------------------------------------------------------

//==========================================================================
//
//	AfterUnarchiveThinkers
//
//==========================================================================

void AfterUnarchiveThinkers(void)
{
}

//==========================================================================
//
//  G_InitNew
//
//==========================================================================

void G_InitNew(int skill)
{
#define SET_MISSILE_SPEED(type, normal_speed, fast_speed) \
	(mobjinfo[type].speed = fastparm ? normal_speed : fast_speed)

	respawnmonsters = GetCvar("RespawnMonsters");
	nomonsters = GetCvar("NoMonsters");
    fastparm = gameskill == sk_nightmare || GetCvar("Fast");

#ifdef FIXME
	// Set monster missile speeds
	SET_MISSILE_SPEED(MT_IMPBALL, 350.0, 700.0);
	SET_MISSILE_SPEED(MT_MUMMYFX1, 315.0, 630.0);
	SET_MISSILE_SPEED(MT_KNIGHTAXE, 315.0, 630.0);
	SET_MISSILE_SPEED(MT_REDAXE, 315.0, 630.0);
	SET_MISSILE_SPEED(MT_BEASTBALL, 420.0, 700.0);
	SET_MISSILE_SPEED(MT_WIZFX1, 630.0, 840.0);
	SET_MISSILE_SPEED(MT_SNAKEPRO_A, 490.0, 700.0);
	SET_MISSILE_SPEED(MT_SNAKEPRO_B, 490.0, 700.0);
	SET_MISSILE_SPEED(MT_HEADFX1, 455.0, 700.0);
	SET_MISSILE_SPEED(MT_HEADFX3, 350.0, 630.0);
	SET_MISSILE_SPEED(MT_MNTRFX1, 700.0, 910.0);
	SET_MISSILE_SPEED(MT_MNTRFX2, 490.0, 700.0);
	SET_MISSILE_SPEED(MT_SRCRFX1, 700.0, 980.0);
	SET_MISSILE_SPEED(MT_SOR2FX1, 700.0, 980.0);
#endif
}

//==========================================================================
//
//  StartLevelLoading
//
//==========================================================================

void StartLevelLoading(void)
{
	InitMonsters();
	OpenWeapons();
    bodyqueslot = 0;
	P_InitAmbientSound();
}

//==========================================================================
//
//  EndLevelLoading
//
//==========================================================================

void EndLevelLoading(void)
{
}

//==========================================================================
//
//  main
//
//==========================================================================

void main(void)
{
	InitLava();
	shareware = GetCvar("shareware");
}
