//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2001 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

int			Datagram_Init(void);
void		Datagram_Listen(boolean state);
void		Datagram_SearchForHosts(boolean xmit);
qsocket_t	*Datagram_Connect(char *host);
qsocket_t 	*Datagram_CheckNewConnections(void);
int			Datagram_GetMessage(qsocket_t *sock);
int			Datagram_SendMessage(qsocket_t *sock, TSizeBuf *data);
int			Datagram_SendUnreliableMessage(qsocket_t *sock, TSizeBuf *data);
boolean		Datagram_CanSendMessage(qsocket_t *sock);
boolean		Datagram_CanSendUnreliableMessage(qsocket_t *sock);
void		Datagram_Close(qsocket_t *sock);
void		Datagram_Shutdown(void);
