//**************************************************************************
//**
//**	##   ##    ##    ##   ##   ####     ####   ###     ###
//**	##   ##  ##  ##  ##   ##  ##  ##   ##  ##  ####   ####
//**	 ## ##  ##    ##  ## ##  ##    ## ##    ## ## ## ## ##
//**	 ## ##  ########  ## ##  ##    ## ##    ## ##  ###  ##
//**	  ###   ##    ##   ###    ##  ##   ##  ##  ##       ##
//**	   #    ##    ##    #      ####     ####   ##       ##
//**
//**	Copyright (C) 1999-2000 Jnis Legzdi
//**
//**	This program is free software; you can redistribute it and/or
//**  modify it under the terms of the GNU General Public License
//**  as published by the Free Software Foundation; either version 2
//**  of the License, or (at your option) any later version.
//**
//**	This program is distributed in the hope that it will be useful,
//**  but WITHOUT ANY WARRANTY; without even the implied warranty of
//**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//**  GNU General Public License for more details.
//**	
//**************************************************************************

#include "../../makeinfo.h"

state_action_info_t StateActionInfo[] =
{
	{NULL},
	{"A_FreeTargMobj"},
    {"A_RestoreSpecialThing1"},
    {"A_RestoreSpecialThing2"},
    {"A_HideThing"},
    {"A_UnHideThing"},
    {"A_RestoreArtifact"},
    {"A_Scream"},
    {"A_Explode"},
    {"A_PodPain"},
    {"A_RemovePod"},

    {"A_MakePod"},
    {"A_InitKeyGizmo"},
    {"A_VolcanoSet"},
    {"A_VolcanoBlast"},
    {"A_BeastPuff"},
    {"A_VolcBallImpact"},
    {"A_SpawnTeleGlitter"},
    {"A_SpawnTeleGlitter2"},
    {"A_AccTeleGlitter"},
    {"A_Light0", 1},

    {"A_WeaponReady", 1},
    {"A_Lower", 1},
    {"A_Raise", 1},
    {"A_StaffAttackPL1", 1},
    {"A_ReFire", 1},
    {"A_StaffAttackPL2", 1},
    {"A_BeakReady", 1},
    {"A_BeakRaise", 1},
    {"A_BeakAttackPL1", 1},
    {"A_BeakAttackPL2", 1},

    {"A_GauntletAttack", 1},
    {"A_FireBlasterPL1", 1},
    {"A_FireBlasterPL2", 1},
    {"A_SpawnRippers"},
    {"A_FireMacePL1", 1},
    {"A_FireMacePL2", 1},
    {"A_MacePL1Check"},
    {"A_MaceBallImpact"},
    {"A_MaceBallImpact2"},
    {"A_DeathBallImpact"},

    {"A_FireSkullRodPL1", 1},
    {"A_FireSkullRodPL2", 1},
    {"A_SkullRodPL2Seek"},
    {"A_AddPlayerRain"},
    {"A_HideInCeiling"},
    {"A_SkullRodStorm"},
    {"A_RainImpact"},
    {"A_FireGoldWandPL1", 1},
    {"A_FireGoldWandPL2", 1},
    {"A_FirePhoenixPL1", 1},

    {"A_InitPhoenixPL2", 1},
    {"A_FirePhoenixPL2", 1},
    {"A_ShutdownPhoenixPL2", 1},
    {"A_PhoenixPuff"},
    {"A_FlameEnd"},
    {"A_FloatPuff"},
    {"A_FireCrossbowPL1", 1},
    {"A_FireCrossbowPL2", 1},
    {"A_BoltSpark"},
    {"A_Pain"},

	{"A_NoBlocking"},
    {"A_AddPlayerCorpse"},
    {"A_SkullPop"},
    {"A_FlameSnd"},
    {"A_CheckBurnGone"},
    {"A_CheckSkullFloor"},
    {"A_CheckSkullDone"},
    {"A_Feathers"},
    {"A_ChicLook"},
    {"A_ChicChase"},

    {"A_ChicPain"},
    {"A_FaceTarget"},
    {"A_ChicAttack"},
    {"A_Look"},
    {"A_Chase"},
    {"A_MummyAttack"},
    {"A_MummyAttack2"},
    {"A_MummySoul"},
    {"A_ContMobjSound"},
    {"A_MummyFX1Seek"},

    {"A_BeastAttack"},
    {"A_SnakeAttack"},
    {"A_SnakeAttack2"},
    {"A_HeadAttack"},
    {"A_BossDeath"},
    {"A_HeadIceImpact"},
    {"A_HeadFireGrow"},
    {"A_WhirlwindSeek"},
    {"A_ClinkAttack"},
    {"A_WizAtk1"},

    {"A_WizAtk2"},
    {"A_WizAtk3"},
    {"A_GhostOff"},
    {"A_ImpMeAttack"},
    {"A_ImpMsAttack"},
    {"A_ImpMsAttack2"},
    {"A_ImpDeath"},
    {"A_ImpXDeath1"},
    {"A_ImpXDeath2"},
    {"A_ImpExplode"},

    {"A_KnightAttack"},
    {"A_DripBlood"},
    {"A_Sor1Chase"},
    {"A_Sor1Pain"},
    {"A_Srcr1Attack"},
    {"A_SorZap"},
    {"A_SorcererRise"},
    {"A_SorRise"},
    {"A_SorSightSnd"},
    {"A_Srcr2Decide"},

    {"A_Srcr2Attack"},
    {"A_Sor2DthInit"},
    {"A_SorDSph"},
    {"A_Sor2DthLoop"},
    {"A_SorDExp"},
    {"A_SorDBon"},
    {"A_BlueSpark"},
    {"A_GenWizard"},
    {"A_MinotaurAtk1"},
    {"A_MinotaurDecide"},

    {"A_MinotaurAtk2"},
    {"A_MinotaurAtk3"},
    {"A_MinotaurCharge"},
    {"A_MntrFloorFire"},
    {"A_ESound"},
	{NULL},
};
